package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.CallResult;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.dao.ModelVersionMapper;
import com.yice.webadmin.app.model.ModelVersion;
import com.yice.webadmin.app.service.ModelManageService;
import com.yice.webadmin.app.service.ModelTaskService;
import com.yice.webadmin.app.service.ModelVersionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 模型版本数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("modelVersionService")
public class ModelVersionServiceImpl extends BaseService<ModelVersion, Long> implements ModelVersionService {

    @Autowired
    private ModelVersionMapper modelVersionMapper;
    @Autowired
    private ModelManageService modelManageService;
    @Autowired
    private ModelTaskService modelTaskService;
    @Autowired
    private IdGeneratorWrapper idGenerator;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<ModelVersion> mapper() {
        return modelVersionMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param modelVersion 新增对象。
     * @return 返回新增对象。
     */
    @Override
    public ModelVersion saveNew(ModelVersion modelVersion) {
        String modelName = this.modelManageService.getById(modelVersion.getModelId()).getModelName();
        ModelVersion modelVersionFilter = new ModelVersion();
        modelVersionFilter.setModelId(modelVersion.getModelId());
        List<ModelVersion> modelVersionList = this.getModelVersionList(modelVersionFilter, "model_Version");
        Integer version = 1;
        if (modelVersionList != null && modelVersionList.size() != 0) {
            version = modelVersionList.get(modelVersionList.size() - 1).getModelVersion() + 1;
        }
        modelVersion.setModelVersion(version);
        if (modelVersion.getIsCompress() == null) {
            modelVersion.setIsCompress(0);
        }
        modelVersion.setVersionName(modelName + "_V" + modelVersion.getModelVersion());
        modelVersionMapper.insert(this.buildDefaultValue(modelVersion));
        return modelVersion;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param modelVersionList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<ModelVersion> modelVersionList) {
        if (CollUtil.isNotEmpty(modelVersionList)) {
            modelVersionList.forEach(this::buildDefaultValue);
            modelVersionMapper.insertList(modelVersionList);
        }
    }

    /**
     * 更新数据对象。
     *
     * @param modelVersion         更新的对象。
     * @param originalModelVersion 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(ModelVersion modelVersion, ModelVersion originalModelVersion) {
        MyModelUtil.fillCommonsForUpdate(modelVersion, originalModelVersion);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<ModelVersion> uw = this.createUpdateQueryForNullValue(modelVersion, modelVersion.getVersionId());
        return modelVersionMapper.update(modelVersion, uw) == 1;
    }

    /**
     * 删除指定数据。
     *
     * @param versionId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long versionId) {
        return modelVersionMapper.deleteById(versionId) == 1;
    }

    /**
     * 当前服务的支持表为从表，根据主表的关联Id，删除一对多的从表数据。
     *
     * @param modelId 从表关联字段。
     * @return 删除数量。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public int removeByModelId(Long modelId) {
        ModelVersion deletedObject = new ModelVersion();
        deletedObject.setModelId(modelId);
        return modelVersionMapper.delete(new QueryWrapper<>(deletedObject));
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateBatchByModelId(Long modelId, List<ModelVersion> dataList) {
        this.updateBatchOneToManyRelation("modelId", modelId,
                null, null, dataList, this::saveNewBatch);
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getModelVersionListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<ModelVersion> getModelVersionList(ModelVersion filter, String orderBy) {
        return modelVersionMapper.getModelVersionList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getModelVersionList)，以便获取更好的查询性能。
     *
     * @param filter  主表过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<ModelVersion> getModelVersionListWithRelation(ModelVersion filter, String orderBy) {
        List<ModelVersion> resultList = modelVersionMapper.getModelVersionList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.full(), batchSize);
        return resultList;
    }

    @Override
    public ModelVersion lastModelVersion(Long modelId) {
        ModelVersion modelVersionFilter = new ModelVersion();
        modelVersionFilter.setModelId(modelId);
        List<ModelVersion> modelVersions = this.getModelVersionList(modelVersionFilter, "model_version");
        return modelVersions.get(modelVersions.size() - 1);
    }

    /**
     * 根据最新对象和原有对象的数据对比，判断关联的字典数据和多对一主表数据是否都是合法数据。
     *
     * @param modelVersion         最新数据对象。
     * @param originalModelVersion 原有数据对象。
     * @return 数据全部正确返回true，否则false。
     */
    @Override
    public CallResult verifyRelatedData(ModelVersion modelVersion, ModelVersion originalModelVersion) {
        String errorMessageFormat = "数据验证失败，关联的%s并不存在，请刷新后重试！";
        //这里是一对多的验证
        if (this.needToVerify(modelVersion, originalModelVersion, ModelVersion::getModelId)
                && !modelManageService.existId(modelVersion.getModelId())) {
            return CallResult.error(String.format(errorMessageFormat, "模型ID"));
        }
        return CallResult.ok();
    }

    private ModelVersion buildDefaultValue(ModelVersion modelVersion) {
        if (modelVersion.getVersionId() == null) {
            modelVersion.setVersionId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(modelVersion);
        return modelVersion;
    }
}
